---
# Official framework image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/node/tags/
stages:
  - test
  - release

# https://docs.gitlab.com/ee/ci/yaml/README.html#variables
variables:
  FOSSA_API_KEY: "${FOSSA_API_KEY}"
  GITLAB_RESOURCE: "${GITLAB_RESOURCE}"
  GIT_STRATEGY: clone
  GITLAB_TOKEN: "${GITLAB_TOKEN}"
  NODEENV: "development"
  NODE_ENV: "development"
  PRODUCT_NAME: "@data-leakage-protection/signatures"
  PRODUCT_VERSION: "$(npm --loglevel silent run vars:package:version)"
  SONAR_BRANCH_NAME: "echo $(npm --loglevel silent run vars:git:branch:name)"
  SONAR_BRANCH_TARGET: "master"
  SONAR_TOKEN: "${DLP_SONAR_TOKEN}"

# Cache resources among jobs
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/
    - /root/.sonar/cache/
  untracked: true

before_script:
  - npm install
  - npm rebuild
  - npm start

# JOB: test-specs-review-quality
#
# Run install, unit test, and run quality assurance checks for:
# - Code style
# - Security
# - JavaScript best practices
# - Code coverage
# - Dependency security audits
# - Duplicate dependency resolution and removal
# - SonarCloud: send quality metrics to SonarCloud
test-specs-and-review-quality:
  stage: test
  image: gregswindle/ubuntu-gradle-java-node
  script:
    ##########
    # ci:test:
    # - lints javascript
    # - executes unit tests
    # - generates junit.xml results
    ###########
    # postci:test runs:
    # - security:audit for know vulnerabilities in dependencies
    # - qa:review:sonar
    - npm run ci:test
  artifacts:
    reports:
      junit: jest-junit.xml
      codequality: sonar-test-report.xml
  only:
    - merge_requests
    - pushes

# test-license-compliance:
#   stage: test
#   image: node:latest
#   variables:
#     FOSSA_API_KEY: "${FOSSA_API_KEY}"
#   before_script:
#     - curl https://raw.githubusercontent.com/fossas/fossa-cli/master/install.sh | bash
#     - fossa --help
#   script:
#     - FOSSA_API_KEY=${FOSSA_API_KEY} fossa analyze
#     - fossa test
#   allow_failure: true
#   only:
#     - merge_requests
#     - pushes

# JOB: semantic-release
#
# With every merge into master:
# - Generate or append a CHANGELOG.md file
# - Create a Gitlab Release
# - Automatically increment (bump) the project's semantic version based on change types
# - Publish to npm registry
semantic-release:
  stage: release
  image: gregswindle/ubuntu-gradle-java-node
  variables:
    NODE_ENV: "production"
  only:
    - master
  script:
    - npx semantic-release --no-ci
